#!/usr/bin/perl

#------------------------------------------------------------#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) 
 {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
 }
$temp = $ENV{'QUERY_STRING'};
@pairs = split(/&/,$temp);
foreach $item(@pairs) 
 {
  ($key, $content) = split (/=/, $item, 2);
  $content =~ tr/+/ /;
  $content =~ s/%(..)/pack("c",hex($1))/ge;
  $FORM{$key} = $content;
 }
#------------------------------------------------------------#
sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }

sub get_WORD
 { return unpack "v", (substr $_[0],$_[1],4); }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub reset_document
 {
  $stat_info =~ s/\x5c/\\x5c/g;
  my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";
  print <<HTML;
  <script type='text/javascript'><!--
  parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
  parent.document.load_changes_form.reset();
  parent.FLAG_no_action = 0;
  parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
  // --></script>
HTML

  exit;
 }
#-----------------------------------------------------------------------#

print "content-type: text/html; charset=Windows-1251\n\n";

if(!-r $FORM{'load_patch_path'})
 { $stat_info .= (":  ".$FORM{'load_patch_path'}."    !<br>"); reset_document(); };
#    
open FILE,$FORM{'load_patch_path'}; binmode FILE; 
#     ( )
(undef, undef, undef, undef, undef, undef, undef, $patch_file_size) = stat FILE;
#    
seek FILE,0,0;
#      
read FILE,$patch_file_content,$patch_file_size;
#  
close FILE;

$stat_info .= (" : ".$FORM{'load_patch_path'}." ...<br>");

#   
my $current_add_string;

#  
my $added_strings = 0;

my $FLAG_num_file = 0;


if($patch_file_content =~ /^([0-9]{1,6}),/)
 {
  #   num-
  my $temp_patch_file_content;
	#    num-
  my @splitted_patch_file_content = split ",", $patch_file_content;
  for my $n (0..$#splitted_patch_file_content)
   {
    #           tlk-
    if($splitted_patch_file_content[$n] <= $FORM{'current_file_strings'})
     { $temp_patch_file_content .= ($splitted_patch_file_content[$n]).","; };
   }
  #       num-
  $temp_patch_file_content =~ s/(,){1,}$//;
  #    num-  - 
	$patch_file_content = $temp_patch_file_content;

	$add_string_number_joined = $patch_file_content;

  if($FORM{'sort_by_string_number'} eq 0)
   { $stat_info .= ("-> num-,    ...    <br>"); }
  elsif($FORM{'sort_by_string_number'} eq 1)
   { $stat_info .= ("-> num-,    ...    <br>"); };

  #      
  if($FORM{'open_match'} eq 0){ $current_add_string = $FORM{'string_number'}; }
  #   
  elsif($FORM{'open_match'} eq 1 && $patch_file_content =~ /^([0-9]{1,6}),/){ $current_add_string = $1; }
  #   
  elsif($FORM{'open_match'} eq 2 && $patch_file_content =~ /,([0-9]{1,6})$/){ $current_add_string = $1; }
 
  if(!-r $FORM{'main_file'})
   { $stat_info .= (":  ".$FORM{'main_file'}."       !<br>"); reset_document(); };
  open FILE,$FORM{'main_file'}; binmode FILE;
  #   
  seek FILE,4,0; read FILE,$file_version,4;
  #   
  seek FILE,0,0; read FILE,$file_type,4;
  if($file_type ne "TLK ")
   { $stat_info .= (":  ".$FORM{'main_file'}."   TLK !<br>"); }
  elsif($file_version eq "V3.0")
   {
    #  
    $header_length = 20;
    #    
    $string_data_length = 40;
    #    
    seek FILE,12,0; read FILE,$file_strings,4; $file_strings = (unpack "V", $file_strings) - 1;
    #        
    seek FILE,16,0; read FILE,$strings_offset,4; $strings_offset = unpack "V", $strings_offset;
    #     
    seek FILE,$header_length + $string_data_length * $current_add_string,0; read FILE,$sdt_offset,$string_data_length;
    $string_offset = $strings_offset + (unpack "V", substr $sdt_offset,28,4);
    #    
    $string_length = unpack "V", substr $sdt_offset,32,4;
    #  
    seek FILE,$string_offset,0; read FILE,$string_text,$string_length;
    #  
    $string_flag = get_DWORD($sdt_offset,0);
    #     
    $sound_link = substr $sdt_offset,4,16; $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    #      
    $sound_volume = get_DWORD($sdt_offset,20);
    #  /    
    $sound_pitch = get_DWORD($sdt_offset,24);
    #    32-   
    $sound_length = unpack "f", (substr $sdt_offset,36,4);
   }
  elsif($file_version eq "V1  ")
   {
    $header_length = 18;
    $string_data_length = 26;
    seek FILE,10,0; read FILE,$file_strings,4; $file_strings = (unpack "V", $file_strings) - 1;
    seek FILE,14,0; read FILE,$strings_offset,4; $strings_offset = unpack "V", $strings_offset;
    seek FILE,$header_length + $string_data_length * $current_add_string,0; read FILE,$sdt_offset,$string_data_length;
    $string_offset = $strings_offset + (unpack "V", substr $sdt_offset,18,4);
    $string_length = unpack "V", substr $sdt_offset,22,4;
    seek FILE,$string_offset,0; read FILE,$string_text,$string_length;
    $string_flag = get_WORD($sdt_offset,0);
    $sound_link = substr $sdt_offset,2,8; $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    $sound_volume = get_DWORD($sdt_offset,10);
    $sound_pitch = get_DWORD($sdt_offset,14);
    $sound_length = " ";
   }
  else{ $stat_info .= (":   ".$FORM{'main_file'}."  !<br>"); }
  close FILE;
  if($file_type eq "TLK " && ($file_version eq "V3.0" || $file_version eq "V1  "))
   {
    $stat_info .= (" : ".$FORM{'main_file'}." ...<br>-> : $file_type, : $file_version<br>-> : $current_add_string ... $string_length    $string_offset<br>");
    #   (5c),   (0a  0d)   (22)  
    $string_text =~ s/\x5c/\\x5c/g;
    $string_text =~ s/\x0a/\\x0a/g;
    $string_text =~ s/\x0d/\\x0d/g;
    $string_text =~ s/\x22/\\x22/g;

    $FLAG_num_file = 1;
   }
 }
elsif($patch_file_content =~ /StringRef: [0-9]{1,6}\n/)
 {
  $stat_info .= ("-> txt- (.)<br>->    ... ");

  #    
  $patch_file_content =~ s/\r//g;
  #       
  my @patch_file_content_array = split "StringRef: ", $patch_file_content;

  if($FORM{'sort_by_string_number'} eq 0)
   {
    $stat_info .= ("   <br>");
    for my $n (1..$#patch_file_content_array)
     {
      #   
      my $current_content = $patch_file_content_array[$n];
      #     
      my $current_number;
      #    
      if($current_content =~ s/{!StringRef:([0-9]{1,6})!}//g)
       {
        #   
        $current_number = $1;
        #      
        $current_content =~ s/[0-9]{1,6}\n//;
       }
      elsif($current_content =~ s/([0-9]{1,6})\n//)
       {
        #   
        $current_number = $1;
       }
      #       
      $current_content =~ s/(\n){1,}$//;
      #      
      push @patch_string_number,$current_number;
      push @patch_string_content,$current_content;
      #    
      if($FORM{'current_file_strings'} < $current_number){ $added_strings++; };
     }
   }
  elsif($FORM{'sort_by_string_number'} eq 1)
   {
    $stat_info .= ("c   <br>");
    for my $n (1..$#patch_file_content_array)
     {
      my $current_content = $patch_file_content_array[$n];
      my $current_number;
      if($current_content =~ s/{!StringRef:([0-9]{1,6})!}//g)
       { $current_number = $1; $current_content =~ s/[0-9]{1,6}\n//; }
      elsif($current_content =~ s/([0-9]{1,6})\n//)
       { $current_number = $1; }
      $current_content =~ s/(\n){1,}$//;
      $patch_strings{$current_number} = $current_content;
      if($FORM{'current_file_strings'} < $current_number){ $added_strings++; };
     }
    #     
    foreach my $sorted_key (sort {$a <=> $b} keys %patch_strings)
     { push @patch_string_number, $sorted_key; push @patch_string_content, $patch_strings{$sorted_key}; }
   }

  $add_string_number_joined = join ",", @patch_string_number;
  $add_string_content_joined = join "{!join!}", @patch_string_content;

  if($#patch_string_number eq "-1")
   {
    $stat_info .= (":  ".$FORM{'load_patch_path'}."      !<br>");
    reset_document();
   };
  #   \
  $add_string_content_joined =~ s/\x5c/\\x5c/g;
  #    \n
  $add_string_content_joined =~ s/\x0a/\\x0a/g;
  #    "
  $add_string_content_joined =~ s/\x22/\\x22/g;
  $stat_info .= ("->  : ".($#patch_string_number+1)." (: ".$added_strings.")<br>");

  if($FORM{'open_match'} eq 0){ $current_add_string = $FORM{'string_number'}; }
  elsif($FORM{'open_match'} eq 1){ $current_add_string = @patch_string_number[0]; }
  elsif($FORM{'open_match'} eq 2){ $current_add_string = @patch_string_number[$#patch_string_number]; }
  $patch_file_content = "";
}
elsif($patch_file_content =~ /@[0-9]{1,6} {0,}= {0,}~[^~]*~/)
 {
  $stat_info .= ("-> tra- (WeiDU)<br>->    ... ");
  #    
  $patch_file_content =~ s/\r//g;

  if($FORM{'sort_by_string_number'} eq 0)
   {
    $stat_info .= ("   <br>");
    while($patch_file_content =~ s/@([0-9]{1,6}) = ~([^~]*)~//)
     {
      #      
      my $current_number = $1;
      my $current_content = $2;

      if($current_content =~ s/{!StringRef:([0-9]{1,6})!}//g){ push @patch_string_number,$1; }
      else{ push @patch_string_number,$current_number; }
      push @patch_string_content,$current_content;
      #    
      if($FORM{'current_file_strings'} < $current_number){ $added_strings++; };
     }
   }
  elsif($FORM{'sort_by_string_number'} eq 1)
   {
    $stat_info .= ("   <br>");
    while($patch_file_content =~ s/@([0-9]{1,6}) = ~([^~]*)~//)
     {
      my $current_number = $1;
      my $current_content = $2;

      if($current_content =~ s/{!StringRef:([0-9]{1,6})!}//g){ $current_number = $1; };
      $patch_strings{$current_number} = $current_content;
      if($FORM{'current_file_strings'} < $current_number){ $added_strings++; };
     }
    foreach my $sorted_key (sort {$a <=> $b} keys %patch_strings)
     { push @patch_string_number, $sorted_key; push @patch_string_content, $patch_strings{$sorted_key}; }
   }

  $add_string_number_joined = join ",", @patch_string_number;
  $add_string_content_joined = join "{!join!}", @patch_string_content;

  #      
  $add_string_content_joined =~ s/\{tilde\}/~/g;

  if($#patch_string_number eq "-1")
   {
    $stat_info .= (":  ".$FORM{'load_patch_path'}."      !<br>");
    reset_document();
   };
  #   \
  $add_string_content_joined =~ s/\x5c/\\x5c/g;
  #    \n
  $add_string_content_joined =~ s/\x0a/\\x0a/g;
  #    "
  $add_string_content_joined =~ s/\x22/\\x22/g;
  $stat_info .= ("->  : ".($#patch_string_number+1)." (: ".$added_strings.")<br>");

  if($FORM{'open_match'} eq 0){ $current_add_string = $FORM{'string_number'}; }
  elsif($FORM{'open_match'} eq 1){ $current_add_string = @patch_string_number[0]; }
  elsif($FORM{'open_match'} eq 2){ $current_add_string = @patch_string_number[$#patch_string_number]; }
  $patch_file_content = "";
}
elsif($patch_file_content =~ /<[0-9]{7}>[^(<END>)]*<END>/)
 {
  $stat_info .= ("-> txt- (TeamBG)<br>->    ... ");

  #    
  $patch_file_content =~ s/\r//g;

  #       
  my @patch_file_content_array = split "<END>\n", $patch_file_content;

  if($FORM{'sort_by_string_number'} eq 0)
   {
    $stat_info .= ("   <br>");
    for my $n (0..$#patch_file_content_array)
     {
      #   
      my $current_content = $patch_file_content_array[$n];
      #     
      my $current_number;
      #    
      if($current_content =~ s/{!StringRef:([0-9]{1,6})!}//g)
       {
        #   
        $current_number = $1;
        #      
        $current_content =~ s/<[0-9]{7}>//;
       }
      elsif($current_content =~ s/<[0]{1,6}([0-9]{1,7})>//)
       {
        #   
        $current_number = $1;
       }
      #       
      $current_content =~ s/(\n){1,}$//;
      #      
      push @patch_string_number,$current_number;
      push @patch_string_content,$current_content;
      #    
      if($FORM{'current_file_strings'} < $current_number){ $added_strings++; };
     }
   }
  elsif($FORM{'sort_by_string_number'} eq 1)
   {
    $stat_info .= ("   <br>");
    for my $n (0..$#patch_file_content_array)
     {
      my $current_content = $patch_file_content_array[$n];
      my $current_number;
      if($current_content =~ s/{!StringRef:([0-9]{1,6})!}//g)
       { $current_number = $1; $current_content =~ s/<[0-9]{7}>//; }
      elsif($current_content =~ s/<[0]{1,6}([0-9]{1,7})>//)
       { $current_number = $1; }
      $current_content =~ s/(\n){1,}$//;
      $patch_strings{$current_number} = $current_content;
      if($FORM{'current_file_strings'} < $current_number){ $added_strings++; };
     }
    #     
    foreach my $sorted_key (sort {$a <=> $b} keys %patch_strings)
     { push @patch_string_number, $sorted_key; push @patch_string_content, $patch_strings{$sorted_key}; }
   }

  $add_string_number_joined = join ",", @patch_string_number;
  $add_string_content_joined = join "{!join!}", @patch_string_content;

  if($#patch_string_number eq "-1")
   {
    $stat_info .= (":  ".$FORM{'load_patch_path'}."      !<br>");
    reset_document();
   };
  #   \
  $add_string_content_joined =~ s/\x5c/\\x5c/g;
  #    \n
  $add_string_content_joined =~ s/\x0a/\\x0a/g;
  #    "
  $add_string_content_joined =~ s/\x22/\\x22/g;
  $stat_info .= ("->  : ".($#patch_string_number+1)." (: ".$added_strings.")<br>");

  if($FORM{'open_match'} eq 0){ $current_add_string = $FORM{'string_number'}; }
  elsif($FORM{'open_match'} eq 1){ $current_add_string = @patch_string_number[0]; }
  elsif($FORM{'open_match'} eq 2){ $current_add_string = @patch_string_number[$#patch_string_number]; }
  $patch_file_content = "";
 }
elsif($patch_file_content =~ /#[0-9]{1,6} {1,}\/\* {1,}~[^~]*~ {1,}[ \[\]a-zA-Z0-9]{0,}\*\//)
 {
  $stat_info .= ("d- (WeiDU)<br>->    ... ");

  #    
  $patch_file_content =~ s/\r//g;

  if($FORM{'sort_by_string_number'} eq 0)
   {
    $stat_info .= ("   <br>");
    #       
    while($patch_file_content =~ s/#([0-9]{1,6}) {1,}\/\* {1,}~([^~]*)~ {1,}[ \[\]a-zA-Z0-9]{0,}\*\///)
     {
      #      
      my $current_number = $1;
      my $current_content = $2;

      if($current_content =~ s/{!StringRef:([0-9]{1,6})!}//g){ push @patch_string_number,$1; }
      else{ push @patch_string_number,$current_number; }
      #      
      push @patch_string_content,$current_content;
      #    
      if($FORM{'current_file_strings'} < $1){ $added_strings++; };
     }
   }
  if($FORM{'sort_by_string_number'} eq 1)
   {
    $stat_info .= ("   <br>");
    while($patch_file_content =~ s/#([0-9]{1,6}) {1,}\/\* {1,}~([^~]*)~ {1,}[ \[\]a-zA-Z0-9]{0,}\*\///)
     {
      my $current_number = $1;
      my $current_content = $2;

      if($current_content =~ s/{!StringRef:([0-9]{1,6})!}//g){ $current_number = $1; };
      $patch_strings{$current_number} = $current_content;
      if($FORM{'current_file_strings'} < $1){ $added_strings++; };
     }
    foreach my $sorted_key (sort {$a <=> $b} keys %patch_strings)
     { push @patch_string_number, $sorted_key; push @patch_string_content, $patch_strings{$sorted_key}; }
   }

  $add_string_number_joined = join ",", @patch_string_number;
  $add_string_content_joined = join "{!join!}", @patch_string_content;

  if($#patch_string_number eq "-1")
   {
    $stat_info .= (":  ".$FORM{'load_patch_path'}."      !<br>");
    reset_document();
   };
  #   \
  $add_string_content_joined =~ s/\x5c/\\x5c/g;
  #    \n
  $add_string_content_joined =~ s/\x0a/\\x0a/g;
  #    "
  $add_string_content_joined =~ s/\x22/\\x22/g;
  $stat_info .= ("->  : ".($#patch_string_number+1)." (: ".$added_strings.")<br>");

  if($FORM{'open_match'} eq 0){ $current_add_string = $FORM{'string_number'}; }
  elsif($FORM{'open_match'} eq 1){ $current_add_string = @patch_string_number[0]; }
  elsif($FORM{'open_match'} eq 2){ $current_add_string = @patch_string_number[$#patch_string_number]; }
  $patch_file_content = "";
 }
elsif($patch_file_content =~ s/> ([0-9]{1,6})/StringRef: $1/g)
 {
  $stat_info .= ("-> patch- (BG Hacking Project)<br>->    ... ");
  #    
  $patch_file_content =~ s/\r//g;
  #       
  my @patch_file_content_array = split "StringRef: ", $patch_file_content;

  if($FORM{'sort_by_string_number'} eq 0)
   {
    $stat_info .= ("   <br>");
    for my $n (1..$#patch_file_content_array)
     {
      #   
      my $current_content = $patch_file_content_array[$n];
      #     
      my $current_number;
      #    
      if($current_content =~ s/{!StringRef:([0-9]{1,6})!}//g)
       {
        #   
        $current_number = $1;
        #      
        $current_content =~ s/[0-9]{1,6}\n//;
       }
      elsif($current_content =~ s/([0-9]{1,6})\n//)
       {
        #   
        $current_number = $1;
       }

      #    
      push @patch_string_number,$current_number;
      push @patch_string_content,$current_content;
      #    
      if($FORM{'current_file_strings'} < $current_number){ $added_strings++; };
     }
   }
  elsif($FORM{'sort_by_string_number'} eq 1)
   {
    $stat_info .= ("c   <br>");
    for my $n (1..$#patch_file_content_array)
     {
      my $current_content = $patch_file_content_array[$n];
      my $current_number;
      if($current_content =~ s/{!StringRef:([0-9]{1,6})!}//g)
       { $current_number = $1; $current_content =~ s/[0-9]{1,6}\n//; }
      elsif($current_content =~ s/([0-9]{1,6})\n//)
       { $current_number = $1; }
      $patch_strings{$current_number} = $current_content;
      if($FORM{'current_file_strings'} < $1){ $added_strings++; };
     }
    #     
    foreach my $sorted_key (sort {$a <=> $b} keys %patch_strings)
     { push @patch_string_number, $sorted_key; push @patch_string_content, $patch_strings{$sorted_key}; }
   }

  $add_string_number_joined = join ",", @patch_string_number;
  $add_string_content_joined = join "{!join!}", @patch_string_content;

  if($#patch_string_number eq "-1")
   {
    $stat_info .= (":  ".$FORM{'load_patch_path'}."      !<br>");
    reset_document();
   };
  #   \
  $add_string_content_joined =~ s/\x5c/\\x5c/g;
  #    \n
  $add_string_content_joined =~ s/\x0a/\\x0a/g;
  #    "
  $add_string_content_joined =~ s/\x22/\\x22/g;
  $stat_info .= ("->  : ".($#patch_string_number+1)." (: ".$added_strings.")<br>");

  if($FORM{'open_match'} eq 0){ $current_add_string = $FORM{'string_number'}; }
  elsif($FORM{'open_match'} eq 1){ $current_add_string = @patch_string_number[0]; }
  elsif($FORM{'open_match'} eq 2){ $current_add_string = @patch_string_number[$#patch_string_number]; }
  $patch_file_content = "";
 }
elsif((substr $patch_file_content,0,4) =~ /DLG / && (substr $patch_file_content,4,4) =~ /V1\.0/)
 {
  #     
  $FORM{'sort_by_string_number'} = 0;
  #    
  $FORM{'open_match'} = 1;

  my $Signature = substr $patch_file_content,0,4;
  my $Version = substr $patch_file_content,4,4;
  my $numbers_of_States = get_DWORD(substr $patch_file_content,8,4);
  my $offset_of_State_Tables = get_DWORD(substr $patch_file_content,12,4);
  my $numbers_of_Transitions = get_DWORD(substr $patch_file_content,16,4);
  my $offset_of_Transition_Tables = get_DWORD(substr $patch_file_content,20,4);
	my $offset_of_State_Trigger_Tables = get_DWORD(substr $patch_file_content,24,4);
	my $numbers_of_State_Triggers = get_DWORD(substr $patch_file_content,28,4);
	my $offset_of_Transition_Triggers_Tables = get_DWORD(substr $patch_file_content,32,4);
	my $numbers_of_Transition_Triggers = get_DWORD(substr $patch_file_content,36,4);

  $stat_info .= ("-> : ".$Signature.", : ".$Version."<br>->  : ".$numbers_of_States.",      : ".$offset_of_State_Tables."<br>->  : ".$numbers_of_Transitions.",      : ".$offset_of_Transition_Tables."<br>->       : ".$offset_of_State_Trigger_Tables."<br>->   : ".$numbers_of_State_Triggers."<br>->       : ".$offset_of_Transition_Triggers_Tables."<br>->   : ".$numbers_of_Transition_Triggers."<br>");

  #      
  my $text_for_current_State;
  #    
  my $start_dialog_State = 0;
  
  #my $FLAG_count = 0;
	
	sub process_State
	 {
    #if($FLAG_count > 200){ $stat_info .= ": !<br>"; return; };
    #   
    my $current_State_index = $_[0];

    #      
    $Transitions_of_State[$current_State_index][0] = get_DWORD(substr $patch_file_content,$offset_of_State_Tables+4+$current_State_index*16,4);

    #if($Transitions_of_State[$current_State_index][0] == 10516 || $Transitions_of_State[$current_State_index][0] == 26433){ $stat_info .= ":    !<br>"; return; };

    #      
    $Transitions_of_State[$current_State_index][1] = get_DWORD(substr $patch_file_content,$offset_of_State_Tables+8+$current_State_index*16,4);

    #      
    if(!$Transitions_of_State[$current_State_index][2])
     { $Transitions_of_State[$current_State_index][2] = 1; };
    
    #      
    my $current_Transition_index;
    if($Transitions_of_State[$current_State_index][2] <= $Transitions_of_State[$current_State_index][1] && $Transitions_of_State[$current_State_index][2] > 1)
     { $current_Transition_index = $Transitions_of_State[$current_State_index][0] + $Transitions_of_State[$current_State_index][2] - 1; }
    elsif($Transitions_of_State[$current_State_index][2] == 1)
     { $current_Transition_index = $Transitions_of_State[$current_State_index][0]; }

#$FLAG_count++;

    if($current_Transition_index eq "")
     { $stat_info .= "&nbsp;-&nbsp;: $current_State_index ...<br>:    !<br>"; return; };

    if($current_Transition_index > $numbers_of_Transitions)
     { $stat_info .= "&nbsp;-&nbsp;: $current_State_index ...<br>:    ($current_Transition_index)    ($numbers_of_Transitions)!<br>"; return; };

    #      
    push @string_numbers, get_DWORD(substr $patch_file_content,$offset_of_State_Tables+$current_State_index*16,4);

    $stat_info .= "&nbsp;-&nbsp;: $current_State_index, : @string_numbers[$#string_numbers], : $Transitions_of_State[$current_State_index][2]  $Transitions_of_State[$current_State_index][1]<br>";

    #     
    push @in_dialog_processed_States, $current_State_index;
    push @all_processed_States, $current_State_index;

    #       
    my $current_Transition_flags = unpack "b5", (substr $patch_file_content,$offset_of_Transition_Tables+$current_Transition_index*32,4);

    #   0:  ,   
    if((substr $current_Transition_flags,0,1) == 1)
     {
      push @string_numbers, get_DWORD(substr $patch_file_content,$offset_of_Transition_Tables+4+$current_Transition_index*32,4);
      $stat_info .= "&nbsp;-&nbsp;: $current_Transition_index, : @string_numbers[$#string_numbers]<br>";
     };

    #   4:       
    if((substr $current_Transition_flags,4,1) == 1)
     {
      push @string_numbers, get_DWORD(substr $patch_file_content,$offset_of_Transition_Tables+8+$current_Transition_index*32,4);
      $stat_info .= ": <b>  </b>, : $current_Transition_index, : @string_numbers[$#string_numbers]<br>";
     };

    #   3:     
    if((substr $current_Transition_flags,3,1) == 0)
     {
      #   DLG 
      my $current_dlg_name = $FORM{'load_patch_path'};
         $current_dlg_name =~ s/([a-zA-Z0-9]{1,})\.dlg//i; $current_dlg_name = $1;
      #   DLG ,     
      my $current_Transition_link = substr $patch_file_content,$offset_of_Transition_Tables+20+$current_Transition_index*32,8;
         $current_Transition_link =~ s/\W//g;

      #$stat_info .= " DLG : $current_dlg_name,  DLG : $current_Transition_link<br>";
      #      DLG 
      if($current_Transition_link =~ /$current_dlg_name/i)
       {
        #      DLG 
        my $next_State_index = get_DWORD(substr $patch_file_content,$offset_of_Transition_Tables+28+$current_Transition_index*32,4);
        
    if($next_State_index > $numbers_of_States)
     { $stat_info .= ":    ($next_State_index)    ($numbers_of_States)!<br>"; return; };

        #         
        my $FLAG_prev_State_1st = 0;
        foreach my $p (@all_processed_States)
         { if($p == $next_State_index){ $FLAG_prev_State_1st = 1; }; }
        #       
        my $FLAG_prev_State_2nd = 0;
        foreach my $p (@in_dialog_processed_States)
         { if($p == $next_State_index){ $FLAG_prev_State_2nd = 1; }; }

        #     , . . .
        if($FLAG_prev_State_2nd == 1 || ($FLAG_prev_State_1st == 1 && $Transitions_of_State[$next_State_index][2] > $Transitions_of_State[$next_State_index][1]))
        #if($next_State_index < $current_State_index)
         {
          #      
          push @string_numbers, get_DWORD(substr $patch_file_content,$offset_of_State_Tables+$next_State_index*16,4);
             #   ,   
             push @string_numbers, 0;
          #       
          $Transitions_of_State[$current_State_index][2]++;
          #   
          $stat_info .= ": <b></b>, : $next_State_index, : @string_numbers[$#string_numbers-1], : $Transitions_of_State[$next_State_index][2]  $Transitions_of_State[$next_State_index][1]<br> <br>&nbsp;   ...<br>";
          #return;
          return update_Transitions($current_State_index);
         }
        #    
        else{ return process_State($next_State_index); }
       }
      elsif($current_Transition_link eq "")
       { $stat_info .= ":    DLG-!<br>"; return; }
      #      DLG 
      else
       {
        # ?      DLG 
        #my $next_State_index = get_DWORD(substr $patch_file_content,$offset_of_Transition_Tables+28+$current_Transition_index*32,4);
        #   ,   
        push @string_numbers, 0;
        #       
        $Transitions_of_State[$current_State_index][2]++;
        #   
        $stat_info .= ":     <b>$current_Transition_link.dlg</b><br> <br>&nbsp;&nbsp;&nbsp;   ...<br>";
        #return;
        return update_Transitions();
       }
     }
    #   3:  
    else
     {
      #   ,   
      push @string_numbers, 0;
      #       
      $Transitions_of_State[$current_State_index][2]++;
      #   
      $stat_info .= " <br>&nbsp;&nbsp;&nbsp;   ...<br>";
      #return;
      return update_Transitions();
     }
	 }

  sub update_Transitions
   {
    #       
    my $last_State = @in_dialog_processed_States[$#in_dialog_processed_States];
    my $FLAG_stop = 0;
    while($FLAG_stop == 0)
     {
      $stat_info .= "&nbsp;&nbsp;&nbsp;&nbsp;-&nbsp;: $last_State, : $Transitions_of_State[$last_State][2]  $Transitions_of_State[$last_State][1]<br>";
      #        
      if($Transitions_of_State[$last_State][2] > $Transitions_of_State[$last_State][1])
       {
        #       
        pop @in_dialog_processed_States;
        
        #       
        if($#in_dialog_processed_States != -1)
         {
          #       
          $last_State = @in_dialog_processed_States[$#in_dialog_processed_States];
          #       
          $Transitions_of_State[$last_State][2]++;
         }
        else
         {
          $FLAG_stop = 1;
          $#in_dialog_processed_States = -1;
          $stat_info .= "&nbsp;&nbsp;&nbsp;   <br>";
          #return;
          return get_next_State();
         }
       }
      else
       {
        $FLAG_stop = 1;
        $#in_dialog_processed_States = -1;
        $stat_info .= "&nbsp;&nbsp;&nbsp;   <br> <br>";
        #   
        #return;
        return process_State($start_dialog_State);
       }
     }
   }

  sub get_next_State
   {
    if($start_dialog_State + 1 >= $numbers_of_States){ $stat_info .= "<b>  </b><br>"; return; };
    #    
    $start_dialog_State++;
    #      
    if($Transitions_of_State[$start_dialog_State][2] <= $Transitions_of_State[$start_dialog_State][1])
     {
      #$stat_info .= ": $start_dialog_State,     <br>";
      #return;
      $stat_info .= "  <br>";
      return process_State($start_dialog_State);
     }
    #     
    elsif($Transitions_of_State[$start_dialog_State][2] > $Transitions_of_State[$start_dialog_State][1])
     {
      #$stat_info .= ": $start_dialog_State,    <br>";
      #return;
      return get_next_State();
     }
   }

  if($numbers_of_States > 0)
   {
    $stat_info .= "<b>  ...</b><br>";
    process_State($start_dialog_State);
   }
  else
   { $stat_info .= ":    !<br>"; reset_document(); }

  #      
  $add_string_number_joined = join ",", @string_numbers;

  #   
  $current_add_string = @string_numbers[0];

  if(!-r $FORM{'main_file'} && $current_add_string)
   { $stat_info .= (":  ".$FORM{'main_file'}."       !<br>"); reset_document(); };
  open FILE,$FORM{'main_file'}; binmode FILE;
  #   
  seek FILE,4,0; read FILE,$file_version,4;
  #   
  seek FILE,0,0; read FILE,$file_type,4;
  if($file_type ne "TLK ")
   { $stat_info .= (":  ".$FORM{'main_file'}."   TLK !<br>"); }
  elsif($file_version eq "V3.0")
   {
    #  
    $header_length = 20;
    #    
    $string_data_length = 40;
    #    
    seek FILE,12,0; read FILE,$file_strings,4; $file_strings = (unpack "V", $file_strings) - 1;
    #        
    seek FILE,16,0; read FILE,$strings_offset,4; $strings_offset = unpack "V", $strings_offset;
    #     
    seek FILE,$header_length + $string_data_length * $current_add_string,0; read FILE,$sdt_offset,$string_data_length;
    $string_offset = $strings_offset + (unpack "V", substr $sdt_offset,28,4);
    #    
    $string_length = unpack "V", substr $sdt_offset,32,4;
    #  
    seek FILE,$string_offset,0; read FILE,$string_text,$string_length;
    #  
    $string_flag = get_DWORD($sdt_offset,0);
    #     
    $sound_link = substr $sdt_offset,4,16; $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    #      
    $sound_volume = get_DWORD($sdt_offset,20);
    #  /    
    $sound_pitch = get_DWORD($sdt_offset,24);
    #    32-   
    $sound_length = unpack "f", (substr $sdt_offset,36,4);
   }
  elsif($file_version eq "V1  ")
   {
    $header_length = 18;
    $string_data_length = 26;
    seek FILE,10,0; read FILE,$file_strings,4; $file_strings = (unpack "V", $file_strings) - 1;
    seek FILE,14,0; read FILE,$strings_offset,4; $strings_offset = unpack "V", $strings_offset;
    seek FILE,$header_length + $string_data_length * $current_add_string,0; read FILE,$sdt_offset,$string_data_length;
    $string_offset = $strings_offset + (unpack "V", substr $sdt_offset,18,4);
    $string_length = unpack "V", substr $sdt_offset,22,4;
    seek FILE,$string_offset,0; read FILE,$string_text,$string_length;
    $string_flag = get_WORD($sdt_offset,0);
    $sound_link = substr $sdt_offset,2,8; $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    $sound_volume = get_DWORD($sdt_offset,10);
    $sound_pitch = get_DWORD($sdt_offset,14);
    $sound_length = " ";
   }
  else{ $stat_info .= (":   ".$FORM{'main_file'}."  !<br>"); }
  close FILE;
  if($file_type eq "TLK " && ($file_version eq "V3.0" || $file_version eq "V1  ") && $current_add_string)
   {
    $stat_info .= (" : ".$FORM{'main_file'}." ...<br>-> : $file_type, : $file_version<br>-> : $current_add_string ... $string_length    $string_offset<br>");
    #   (5c),   (0a  0d)   (22)  
    $string_text =~ s/\x5c/\\x5c/g;
    $string_text =~ s/\x0a/\\x0a/g;
    $string_text =~ s/\x0d/\\x0d/g;
    $string_text =~ s/\x22/\\x22/g;
   }
 }

elsif((substr $patch_file_content,0,4) =~ /SPL / && (substr $patch_file_content,4,4) =~ /V1  /)
 {
  #     
  $FORM{'sort_by_string_number'} = 0;
  #    
  $FORM{'open_match'} = 1;

  #     
  $add_string_number_joined = "";

  my $Signature = substr $patch_file_content,0,4;
  my $Version = substr $patch_file_content,4,4;
  #   
  my $Spell_Name_Generic = get_DWORD(substr $patch_file_content,8,4);
     if($Spell_Name_Generic eq 9999999 || $Spell_Name_Generic eq 4294967295)
      { $Spell_Name_Generic = ""; }
     else{ $add_string_number_joined .= $Spell_Name_Generic.","; }
  #   
  my $Spell_Description_Generic = get_DWORD(substr $patch_file_content,80,4);
     if($Spell_Description_Generic eq 9999999 || $Spell_Description_Generic eq 4294967295)
      { $Spell_Description_Generic = ""; }
     else{ $add_string_number_joined .= $Spell_Description_Generic.","; }
  #   
  my $Spell_Name_Identified = get_DWORD(substr $patch_file_content,12,4);
     if($Spell_Name_Identified eq 9999999 || $Spell_Name_Identified eq 4294967295)
      { $Spell_Name_Identified = ""; }
     else{ $add_string_number_joined .= $Spell_Name_Identified.","; }
  #   
  my $Spell_Description_Identified = get_DWORD(substr $patch_file_content,84,4);
     if($Spell_Description_Identified eq 9999999 || $Spell_Description_Identified eq 4294967295)
      { $Spell_Description_Identified = ""; }
     else{ $add_string_number_joined .= $Spell_Description_Identified; }
  
  $add_string_number_joined =~ s/\,$//;

  $stat_info .= ("-> : ".$Signature.", : ".$Version."<br>->  : ".$Spell_Name_Generic.",   : ".$Spell_Description_Generic."<br>->  : ".$Spell_Name_Identified.",  : ".$Spell_Description_Identified."<br>");

  if($add_string_number_joined eq ""){ reset_document(); };

  #   
  $current_add_string = ($Spell_Name_Generic ne "") ? $Spell_Name_Generic : $Spell_Name_Identified;

  if(!-r $FORM{'main_file'} && $current_add_string)
   { $stat_info .= (":  ".$FORM{'main_file'}."       !<br>"); reset_document(); };
  open FILE,$FORM{'main_file'}; binmode FILE;
  #   
  seek FILE,4,0; read FILE,$file_version,4;
  #   
  seek FILE,0,0; read FILE,$file_type,4;
  if($file_type ne "TLK ")
   { $stat_info .= (":  ".$FORM{'main_file'}."   TLK !<br>"); }
  elsif($file_version eq "V3.0")
   {
    #  
    $header_length = 20;
    #    
    $string_data_length = 40;
    #    
    seek FILE,12,0; read FILE,$file_strings,4; $file_strings = (unpack "V", $file_strings) - 1;
    #        
    seek FILE,16,0; read FILE,$strings_offset,4; $strings_offset = unpack "V", $strings_offset;
    #     
    seek FILE,$header_length + $string_data_length * $current_add_string,0; read FILE,$sdt_offset,$string_data_length;
    $string_offset = $strings_offset + (unpack "V", substr $sdt_offset,28,4);
    #    
    $string_length = unpack "V", substr $sdt_offset,32,4;
    #  
    seek FILE,$string_offset,0; read FILE,$string_text,$string_length;
    #  
    $string_flag = get_DWORD($sdt_offset,0);
    #     
    $sound_link = substr $sdt_offset,4,16; $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    #      
    $sound_volume = get_DWORD($sdt_offset,20);
    #  /    
    $sound_pitch = get_DWORD($sdt_offset,24);
    #    32-   
    $sound_length = unpack "f", (substr $sdt_offset,36,4);
   }
  elsif($file_version eq "V1  ")
   {
    $header_length = 18;
    $string_data_length = 26;
    seek FILE,10,0; read FILE,$file_strings,4; $file_strings = (unpack "V", $file_strings) - 1;
    seek FILE,14,0; read FILE,$strings_offset,4; $strings_offset = unpack "V", $strings_offset;
    seek FILE,$header_length + $string_data_length * $current_add_string,0; read FILE,$sdt_offset,$string_data_length;
    $string_offset = $strings_offset + (unpack "V", substr $sdt_offset,18,4);
    $string_length = unpack "V", substr $sdt_offset,22,4;
    seek FILE,$string_offset,0; read FILE,$string_text,$string_length;
    $string_flag = get_WORD($sdt_offset,0);
    $sound_link = substr $sdt_offset,2,8; $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    $sound_volume = get_DWORD($sdt_offset,10);
    $sound_pitch = get_DWORD($sdt_offset,14);
    $sound_length = " ";
   }
  else{ $stat_info .= (":   ".$FORM{'main_file'}."  !<br>"); }
  close FILE;
  if($file_type eq "TLK " && ($file_version eq "V3.0" || $file_version eq "V1  ") && $current_add_string)
   {
    $stat_info .= (" : ".$FORM{'main_file'}." ...<br>-> : $file_type, : $file_version<br>-> : $current_add_string ... $string_length    $string_offset<br>");
    #   (5c),   (0a  0d)   (22)  
    $string_text =~ s/\x5c/\\x5c/g;
    $string_text =~ s/\x0a/\\x0a/g;
    $string_text =~ s/\x0d/\\x0d/g;
    $string_text =~ s/\x22/\\x22/g;
   }
 }

elsif((substr $patch_file_content,0,4) =~ /ITM / && (substr $patch_file_content,4,4) =~ /V1  /)
 {
  #     
  $FORM{'sort_by_string_number'} = 0;
  #    
  $FORM{'open_match'} = 1;

  #     
  $add_string_number_joined = "";

  my $Signature = substr $patch_file_content,0,4;
  my $Version = substr $patch_file_content,4,4;
  #   
  my $Item_Name_Generic = get_DWORD(substr $patch_file_content,8,4);
     if($Item_Name_Generic eq 9999999 || $Item_Name_Generic eq 4294967295)
      { $Item_Name_Generic = ""; }
     else{ $add_string_number_joined .= $Item_Name_Generic.","; }
  #   
  my $Item_Description_Generic = get_DWORD(substr $patch_file_content,80,4);
     if($Item_Description_Generic eq 9999999 || $Item_Description_Generic eq 4294967295)
      { $Item_Description_Generic = ""; }
     else{ $add_string_number_joined .= $Item_Description_Generic.","; }
  #   
  my $Item_Name_Identified = get_DWORD(substr $patch_file_content,12,4);
     if($Item_Name_Identified eq 9999999 || $Item_Name_Identified eq 4294967295)
      { $Item_Name_Identified = ""; }
     else{ $add_string_number_joined .= $Item_Name_Identified.","; }
  #   
  my $Item_Description_Identified = get_DWORD(substr $patch_file_content,84,4);
     if($Item_Description_Identified eq 9999999 || $Item_Description_Identified eq 4294967295)
      { $Item_Description_Identified = ""; }
     else{ $add_string_number_joined .= $Item_Description_Identified; }
  
  $add_string_number_joined =~ s/\,$//;

  $stat_info .= ("-> : ".$Signature.", : ".$Version."<br>->  : ".$Item_Name_Generic.",  : ".$Item_Description_Generic."<br>->  : ".$Item_Name_Identified.",  : ".$Item_Description_Identified."<br>");

  if($add_string_number_joined eq ""){ reset_document(); };

  #   
  $current_add_string = ($Item_Name_Generic ne "") ? $Item_Name_Generic : $Item_Name_Identified;

  if(!-r $FORM{'main_file'} && $current_add_string)
   { $stat_info .= (":  ".$FORM{'main_file'}."       !<br>"); reset_document(); };
  open FILE,$FORM{'main_file'}; binmode FILE;
  #   
  seek FILE,4,0; read FILE,$file_version,4;
  #   
  seek FILE,0,0; read FILE,$file_type,4;
  if($file_type ne "TLK ")
   { $stat_info .= (":  ".$FORM{'main_file'}."   TLK !<br>"); }
  elsif($file_version eq "V3.0")
   {
    #  
    $header_length = 20;
    #    
    $string_data_length = 40;
    #    
    seek FILE,12,0; read FILE,$file_strings,4; $file_strings = (unpack "V", $file_strings) - 1;
    #        
    seek FILE,16,0; read FILE,$strings_offset,4; $strings_offset = unpack "V", $strings_offset;
    #     
    seek FILE,$header_length + $string_data_length * $current_add_string,0; read FILE,$sdt_offset,$string_data_length;
    $string_offset = $strings_offset + (unpack "V", substr $sdt_offset,28,4);
    #    
    $string_length = unpack "V", substr $sdt_offset,32,4;
    #  
    seek FILE,$string_offset,0; read FILE,$string_text,$string_length;
    #  
    $string_flag = get_DWORD($sdt_offset,0);
    #     
    $sound_link = substr $sdt_offset,4,16; $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    #      
    $sound_volume = get_DWORD($sdt_offset,20);
    #  /    
    $sound_pitch = get_DWORD($sdt_offset,24);
    #    32-   
    $sound_length = unpack "f", (substr $sdt_offset,36,4);
   }
  elsif($file_version eq "V1  ")
   {
    $header_length = 18;
    $string_data_length = 26;
    seek FILE,10,0; read FILE,$file_strings,4; $file_strings = (unpack "V", $file_strings) - 1;
    seek FILE,14,0; read FILE,$strings_offset,4; $strings_offset = unpack "V", $strings_offset;
    seek FILE,$header_length + $string_data_length * $current_add_string,0; read FILE,$sdt_offset,$string_data_length;
    $string_offset = $strings_offset + (unpack "V", substr $sdt_offset,18,4);
    $string_length = unpack "V", substr $sdt_offset,22,4;
    seek FILE,$string_offset,0; read FILE,$string_text,$string_length;
    $string_flag = get_WORD($sdt_offset,0);
    $sound_link = substr $sdt_offset,2,8; $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    $sound_volume = get_DWORD($sdt_offset,10);
    $sound_pitch = get_DWORD($sdt_offset,14);
    $sound_length = " ";
   }
  else{ $stat_info .= (":   ".$FORM{'main_file'}."  !<br>"); }
  close FILE;
  if($file_type eq "TLK " && ($file_version eq "V3.0" || $file_version eq "V1  ") && $current_add_string)
   {
    $stat_info .= (" : ".$FORM{'main_file'}." ...<br>-> : $file_type, : $file_version<br>-> : $current_add_string ... $string_length    $string_offset<br>");
    #   (5c),   (0a  0d)   (22)  
    $string_text =~ s/\x5c/\\x5c/g;
    $string_text =~ s/\x0a/\\x0a/g;
    $string_text =~ s/\x0d/\\x0d/g;
    $string_text =~ s/\x22/\\x22/g;
   }
 }

else
 {
  $stat_info .= (" ".$FORM{'load_patch_path'}."      !<br>");
  reset_document();
 }
# ***************************************************
#       
# ***************************************************
if($FORM{'add_file'} ne "" && $current_add_string)
 {
  if(!-r $FORM{'add_file'}){ $stat_info .= (":  ".$FORM{'add_file'}."       !<br>"); reset_document(); };
  open FILE2,$FORM{'add_file'}; binmode FILE2;
  #   
  seek FILE2,4,0; read FILE2,$file2_version,4;
  #   
  seek FILE2,0,0; read FILE2,$file2_type,4;
  if($file2_type ne "TLK ")
   { $stat_info .= (":   ".$FORM{'add_file'}."   TLK !<br>"); }
  elsif($file2_version eq "V3.0")
   {
    #  
    $header2_length = 20;
    #    
    $string2_data_length = 40;
    #    
    seek FILE2,12,0; read FILE2,$file2_strings,4; $file2_strings = (unpack "V", $file2_strings) - 1;
    #        
    seek FILE2,16,0; read FILE2,$strings2_offset,4; $strings2_offset = unpack "V", $strings2_offset;
    #     
    $string2_number = ($current_add_string < $file2_strings) ? $current_add_string : $file2_strings;
    #   2   
    seek FILE2,$header2_length + $string2_data_length * $string2_number,0; read FILE2,$sdt2_offset,$string2_data_length;
    $string2_offset = $strings2_offset + (unpack "V", substr $sdt2_offset,28,4);
    #   2  
    $string2_length = unpack "V", substr $sdt2_offset,32,4;
    #   2
    seek FILE2,$string2_offset,0; read FILE2,$string2_text,$string2_length;
   }
  elsif($file2_version eq "V1  ")
   {
    $header2_length = 18;
    $string2_data_length = 26;
    seek FILE2,10,0; read FILE2,$file2_strings,4; $file2_strings = (unpack "V", $file2_strings) - 1;
    seek FILE2,14,0; read FILE2,$strings2_offset,4; $strings2_offset = unpack "V", $strings2_offset;
    $string2_number = ($current_add_string < $file2_strings) ? $current_add_string : $file2_strings;
    seek FILE2,$header2_length + $string2_data_length * $string2_number,0; read FILE2,$sdt2_offset,$string2_data_length;
    $string2_offset = $strings2_offset + (unpack "V", substr $sdt2_offset,18,4);
    $string2_length = unpack "V", substr $sdt2_offset,22,4;
    seek FILE2,$string2_offset,0; read FILE2,$string2_text,$string2_length;
   }
  else{ $stat_info .= (":    ".$FORM{'add_file'}."  !<br>"); }
  close FILE2;
  if($file2_type eq "TLK " && ($file2_version eq "V3.0" || $file2_version eq "V1  "))
   {
    $stat_info .= (" : ".$FORM{'add_file'}." ...<br>-> : $file2_type, : $file2_version<br>-> : $string2_number ... $string2_length    $string2_offset<br>");
    #   (5c),   (0a  0d)   (22)  
    $string2_text =~ s/\x5c/\\x5c/g;
    $string2_text =~ s/\x0a/\\x0a/g;
    $string2_text =~ s/\x0d/\\x0d/g;
    $string2_text =~ s/\x22/\\x22/g;
   }
 };

$stat_info =~ s/\x5c/\\x5c/g;

my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";

my $patch_file_name_for_stat = $FORM{'load_patch_path'};
   $patch_file_name_for_stat =~ s/\x5c/\\x5c/g;

print <<HTML;
<script type='text/javascript'><!--
if("$string2_text")
 {
  parent.document.main_form.string_content2.value = "$string2_text";
  parent.document.main_form.string_content2.title = " .   $string2_number;   /.   .";
 };

function numeric_sort(element1, element2)
 { return (element1 - element2) }
if("$string_text")
 {
  parent.document.getElementById("search_nav").style.display = "";
  parent.document.main_form.search_in_matched.disabled = false;
  parent.document.getElementById("matched_strings_tooltip").title = "  $patch_file_name_for_stat";

  if($FORM{'sort_by_string_number'} == 0)
   { parent.matched_strings = "$add_string_number_joined".split(","); }
  else if($FORM{'sort_by_string_number'} == 1)
   { parent.matched_strings = ("$add_string_number_joined".split(",")).sort(numeric_sort); }

  for(n = 0; n < parent.matched_strings.length; n++)
   { parent.matched_links[parent.matched_strings[n]] = n; }

  if("$FORM{'open_match'}" == 1)
   {
    parent.current_search_position = 0;
    parent.document.main_form.input_matched_string.value = 1;
    if(parent.document.main_form.string_number.value != "$current_add_string")
     { parent.last_string_number = parent.document.main_form.string_number.value;
       parent.document.main_form.string_number.value = "$current_add_string";
       parent.current_string_number = parent.document.main_form.string_number.value; };
    parent.document.main_form.string_content.value = "$string_text";
   }
  else if("$FORM{'open_match'}" == 2)
   {
    parent.current_search_position = eval(parent.matched_strings.length) - 1;
    parent.document.main_form.input_matched_string.value = eval(parent.matched_strings.length);
    if(parent.document.main_form.string_number.value != "$current_add_string")
     { parent.last_string_number = parent.document.main_form.string_number.value;
       parent.document.main_form.string_number.value = "$current_add_string";
       parent.current_string_number = parent.document.main_form.string_number.value; };
    parent.document.main_form.string_content.value = "$string_text";
   }

  parent.document.main_form.input_matched_strings.value = eval(parent.matched_strings.length);

  parent.document.getElementById("string_info").style.display = "";
  parent.document.getElementById("string_no_info").style.display = "none";
  parent.document.main_form.to_undo_button.style.display = "";
  parent.document.main_form.from_undo_button.style.display = "none";

  parent.document.getElementById("string_flag").innerHTML = "$string_flag";
  parent.document.getElementById("string_length").innerHTML = "$string_length";
  parent.document.getElementById("string_offset").innerHTML = "$string_offset";
  parent.document.getElementById("sound_link").innerHTML = "$sound_link";
  parent.document.getElementById("sound_volume").innerHTML = "$sound_volume";
  parent.document.getElementById("sound_pitch").innerHTML = "$sound_pitch";
  parent.document.getElementById("sound_length").innerHTML = "$sound_length";
 }
else if("$add_string_number_joined" && "$add_string_content_joined")
 {
  parent.add_string_number = "$add_string_number_joined".split(",");
  parent.add_string_content = "$add_string_content_joined".split("{!join!}");
  parent.add_patched_strings();
 }

if(parent.document.getElementById('patch_file_menu').style.display == '')
 {
  parent.document.getElementById('save_changes_tbody').style.display = (parent.matched_strings.length > 0 || parent.changed_string_number.length > 0) ? '' : 'none';
  parent.check_save_patch();
 };

parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
parent.document.load_changes_form.reset();
parent.FLAG_no_action = 0;
parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
// --></script>
HTML

